//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GDI+ ֌WTv
//  }EXJ[\ʒũpXo
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2017N0528 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, GDIPAPI, GDIPOBJ;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private 錾 }
    FGPPath1 : TGPGraphicsPath;
    FGPPath2 : TGPGraphicsPath;
  @FGPPen   :TGPPen;
public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin

  //pX̃IuWFNg𐶐
  FGPPath1 := TGPGraphicsPath.Create;
  FGPPath2 := TGPGraphicsPath.Create;

  //FƐ̑w肵ăy𐶐
  FGPPen := TGPPen.Create(aclBlack, 10.0);
end;

//=============================================================================
//  tH[j̏
//=============================================================================
procedure TForm1.FormDestroy(Sender: TObject);
begin
  FreeAndNil(FGPPath1);
  FreeAndNil(FGPPath2);
  FreeAndNil(FGPPen);
end;

//=============================================================================
//  PaintBox1OnMouseMoveCxg
//=============================================================================
procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  LText : string;
begin
  LText := '';

  //Form1ł̍Wlɕϊ
  X := PaintBox1.Left + X;
  Y := PaintBox1.Top + Y;

  if FGPPath1.IsVisible(X, Y) then LText := LText + ' Path1';
  if FGPPath2.IsVisible(X, Y) then LText := LText + ' Path2';

  if FGPPath1.IsOutlineVisible(X, Y, FGPPen) then LText := LText + ' [Path1 ֊s]';
  if FGPPath2.IsOutlineVisible(X, Y, FGPPen) then LText := LText + ' [Path2 ֊s]';

  Label1.Caption := LText;
end;

//=============================================================================
//  PaintBox1OnPaintCxg
//=============================================================================
procedure TForm1.PaintBox1Paint(Sender: TObject);
var
  LLeft      : Single;
  LTop       : Single;
  LWidth     : Single;
  LHeight    : Single;
  LGPGraphic : TGPGraphics;
begin
  LGPGraphic := TGPGraphics.Create(Canvas.Handle);
  //wi𔒂œhׂ
  LGPGraphic.Clear(aclWhite);


  //Form1ł̍Wlɕϊ
  LLeft   := PaintBox1.Left + 40;
  LTop    := PaintBox1.Top + 20;
  LWidth  := 150;
  LHeight := 150;

  //~̃pX2
  FGPPath1.AddEllipse(LLeft,      LTop, LWidth, LHeight);
  FGPPath2.AddEllipse(LLeft + 50, LTop, LWidth, LHeight);

  //pX`
  LGPGraphic.DrawPath(FGPPen, FGPPath1);
  LGPGraphic.DrawPath(FGPPen, FGPPath2);

  LGPGraphic.Free;
end;

end.
