//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GDI+ ֌WTv
//  }EXJ[\ʒũ[Wo
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2017N0528 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, GDIPAPI, GDIPOBJ;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    Label1: TLabel;
    procedure FormDestroy(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private 錾 }
    FGPResion1 : TGPRegion;
    FGPResion2 : TGPRegion;
public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

//=============================================================================
//  tH[j̏
//=============================================================================
procedure TForm1.FormDestroy(Sender: TObject);
begin
  if Assigned(FGPResion1) then  FreeAndNil(FGPResion1);
  if Assigned(FGPResion2) then  FreeAndNil(FGPResion2);
end;

//=============================================================================
//  PaintBox1OnMouseMoveCxg
//=============================================================================
procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  LText : string;
begin
  LText := '';

  //Form1ł̍Wlɕϊ
  X := PaintBox1.Left + X;
  Y := PaintBox1.Top + Y;

  if FGPResion1.IsVisible(MakePoint(X, Y)) then LText := LText + ' Region1';
  if FGPResion2.IsVisible(MakePoint(X, Y)) then LText := LText + ' Region2';

  Label1.Caption := LText;
end;

//=============================================================================
//  PaintBox1OnPaintCxg
//=============================================================================
procedure TForm1.PaintBox1Paint(Sender: TObject);
var
  LLeft      : Single;
  LTop       : Single;
  LWidth     : Single;
  LHeight    : Single;
  LGPGraphic : TGPGraphics;
  LGPPath1   : TGPGraphicsPath;
  LGPPath2   : TGPGraphicsPath;
  LGPBrush   : TGPSolidBrush;
begin
  LGPGraphic := TGPGraphics.Create(Canvas.Handle);
  //wi𔒂œhׂ
  LGPGraphic.Clear(aclWhite);

  if Assigned(FGPResion1) then  FreeAndNil(FGPResion1);
  if Assigned(FGPResion2) then  FreeAndNil(FGPResion2);


  //Form1ł̍Wlɕϊ
  LLeft   := PaintBox1.Left + 40;
  LTop    := PaintBox1.Top + 20;
  LWidth  := 150;
  LHeight := 150;

  //pX̃IuWFNg𐶐
  LGPPath1 := TGPGraphicsPath.Create;
  LGPPath2 := TGPGraphicsPath.Create;

  //~̃pX2
  LGPPath1.AddEllipse(LLeft,      LTop, LWidth, LHeight);
  LGPPath2.AddEllipse(LLeft + 50, LTop, LWidth, LHeight);

  //eX̉~ʂ̃[WƂ
  FGPResion1 := TGPRegion.Create(LGPPath1);
  FGPResion2 := TGPRegion.Create(LGPPath2);

  //hׂ̃uV𐶐ė̈hׂ
  LGPBrush := TGPSolidBrush.Create(aclLightBlue);
  LGPGraphic.FillRegion(LGPBrush, FGPResion1);
  LGPBrush.SetColor(aclGreen);
  LGPGraphic.FillRegion(LGPBrush, FGPResion2);


  LGPGraphic.Free;
  LGPPath1.Free;
  LGPPath2.Free;
  LGPBrush.Free;
end;

end.
